/*-
 * ~~~~~~licensing~~~~~~
 * profile-management
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.management.profile.impl;

import javax.management.NotCompliantMBeanException;

import ru.entaxy.esb.platform.base.management.core.api.EntaxyRuntimeTyped;
import ru.entaxy.esb.platform.core.management.profile.helper.Helpers;
import ru.entaxy.platform.core.management.object.ObjectMBean;
import ru.entaxy.platform.core.management.object.factory.AbstractObjectMBean;
import ru.entaxy.platform.core.management.profile.ConnectorMBean;
import ru.entaxy.platform.objects.runtime.EntaxyRuntimeObject;

// @TODO move string to constant
@EntaxyRuntimeTyped(name = "entaxy.runtime.connector")
@ObjectMBean(subQualifierName = "connector")
public class ConnectorMBeanImpl extends AbstractObjectMBean<ConnectorMBean> implements ConnectorMBean {

    protected Helpers helpers;

    public ConnectorMBeanImpl(EntaxyRuntimeObject entaxyRuntimeObject, Helpers helpers)
            throws NotCompliantMBeanException {
        super(ConnectorMBean.class, entaxyRuntimeObject);
        this.helpers = helpers;
    }

    @Override
    public String getJMXSubQualifierValue() {
        return getObjectId();
    }

    @Override
    public String getFactoryId() {
        return this.entaxyRuntimeObject.getAttributeOrDefault("templateId", super.getFactoryId()).toString();
    }

    @Override
    public String getRegisteredName() {
        return this.entaxyRuntimeObject.getAttributeOrDefault("bundleName", "").toString();
    }

    @Override
    public String getSystem() {
        return this.entaxyRuntimeObject.getAttributeOrDefault("system", "").toString();
    }

    @Override
    public String getClassifier() {
        return this.entaxyRuntimeObject.getAttributeOrDefault("classifier", "").toString();
    }

    @Override
    public String getDisplayName() {
        return this.entaxyRuntimeObject.getAttributeOrDefault("displayName", getObjectId()).toString();
    }

    @Override
    public String getDirection() {
        return this.entaxyRuntimeObject.getAttributeOrDefault("direction", getObjectId()).toString();
    }

    @Override
    public String getProtocol() {
        return this.entaxyRuntimeObject.getAttributeOrDefault("protocol", getObjectId()).toString();
    }

    @Override
    public void start() throws Exception {
        this.helpers.connectorHelper.startConnector(getSystem(), this.getRegisteredName());
    }

    @Override
    public void stop() throws Exception {
        this.helpers.connectorHelper.stopConnector(getSystem(), this.getRegisteredName());
    }
}
